summaryrefslogtreecommitdiff
path: root/Biz/Ci.sh
diff options
context:
space:
mode:
Diffstat (limited to 'Biz/Ci.sh')
-rwxr-xr-xBiz/Ci.sh59
1 files changed, 59 insertions, 0 deletions
diff --git a/Biz/Ci.sh b/Biz/Ci.sh
new file mode 100755
index 0000000..9dbfd5b
--- /dev/null
+++ b/Biz/Ci.sh
@@ -0,0 +1,59 @@
+#!/usr/bin/env bash
+#
+# A simple ci that saves its results in a git note, formatted according to
+# RFC-2822, more or less.
+#
+# To run this manually, exec the script. It will by default run the tests for
+# HEAD, whatever you currently have checked out.
+#
+# It would be cool to use a zero-knowledge proof mechanism here to prove that
+# so-and-so ran the tests, but I'll have to research how to do that.
+#
+##
+ set -uo pipefail
+ [[ -n $(git status -s) ]] && { echo fail: dirty worktree; exit 1; }
+##
+ at=$(date -R)
+ user=$(git config --get user.name)
+ mail=$(git config --get user.email)
+##
+ commit=$(git notes --ref=ci show HEAD || true)
+ if [[ -n "$commit" ]]
+ then
+ if grep -q "Lint-is: good" <<< "$commit"
+ then
+ exit 0
+ fi
+ if grep -q "Test-is: good" <<< "$commit"
+ then
+ exit 0
+ fi
+ fi
+##
+ runlint="$CODEROOT"/_/bin/lint
+ [[ ! -f "$runlint" ]] && bild "${BILD_ARGS:-""}" "${CODEROOT:?}"/Biz/Lint.hs
+ if "$runlint" "${CODEROOT:?}"/**/*
+ then
+ lint_result="good"
+ else
+ lint_result="fail"
+ exit 1
+ fi
+##
+ if bild "${BILD_ARGS:-""}" --test "${CODEROOT:?}"/**/*
+ then
+ test_result="good"
+ else
+ test_result="fail"
+ exit 1
+ fi
+##
+ read -r -d '' note <<EOF
+Lint-is: $lint_result
+Test-is: $test_result
+Test-by: $user <$mail>
+Test-at: $at
+EOF
+##
+ git notes --ref=ci append -m "$note"
+##